git submodule: Add test cases for git submodule add
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
f2dc06a3 7USAGE="[--quiet] [--cached] \
ec05df35 8[add <repo> [-b branch] <path>]|[status|init|update [-i|--init]|summary [-n|--summary-limit <n>] [<commit>]] \
2327f61e 9[--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
8f321a39 10OPTIONS_SPEC=
70c7ac22 11. git-sh-setup
98fcf840 12. git-parse-remote
70c7ac22
LH
13require_work_tree
14
5c08dbbd 15command=
ecda0723 16branch=
70c7ac22
LH
17quiet=
18cached=
19
20#
21# print stuff on stdout unless -q was specified
22#
23say()
24{
25 if test -z "$quiet"
26 then
27 echo "$@"
28 fi
29}
30
f31a522a
ML
31# Resolve relative url by appending to parent's url
32resolve_relative_url ()
33{
98fcf840 34 remote=$(get_default_remote)
8e7e6f39
ML
35 remoteurl=$(git config "remote.$remote.url") ||
36 die "remote ($remote) does not have a url defined in .git/config"
f31a522a 37 url="$1"
99b120af 38 remoteurl=${remoteurl%/}
f31a522a
ML
39 while test -n "$url"
40 do
41 case "$url" in
42 ../*)
43 url="${url#../}"
44 remoteurl="${remoteurl%/*}"
45 ;;
46 ./*)
47 url="${url#./}"
48 ;;
49 *)
50 break;;
51 esac
52 done
99b120af 53 echo "$remoteurl/${url%/}"
f31a522a
ML
54}
55
a7b3269c
DA
56#
57# Get submodule info for registered submodules
58# $@ = path to limit submodule list
59#
60module_list()
61{
62 git ls-files --stage -- "$@" | grep '^160000 '
63}
64
941987a5
LH
65#
66# Map submodule path to submodule name
67#
68# $1 = path
69#
70module_name()
71{
537601ac 72 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
fe22e542 73 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 74 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 75 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
941987a5
LH
76 test -z "$name" &&
77 die "No submodule mapping found in .gitmodules for path '$path'"
78 echo "$name"
79}
33aa6fff
LH
80
81#
82# Clone a submodule
83#
23a485e3 84# Prior to calling, cmd_update checks that a possibly existing
ecda0723 85# path is not a git repository.
23a485e3 86# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
87# since it is the location of a new submodule.
88#
33aa6fff
LH
89module_clone()
90{
91 path=$1
92 url=$2
93
94 # If there already is a directory at the submodule path,
95 # expect it to be empty (since that is the default checkout
96 # action) and try to remove it.
97 # Note: if $path is a symlink to a directory the test will
98 # succeed but the rmdir will fail. We might want to fix this.
99 if test -d "$path"
100 then
101 rmdir "$path" 2>/dev/null ||
102 die "Directory '$path' exist, but is neither empty nor a git repository"
103 fi
104
105 test -e "$path" &&
106 die "A file already exist at path '$path'"
107
108 git-clone -n "$url" "$path" ||
941987a5 109 die "Clone of '$url' into submodule path '$path' failed"
33aa6fff
LH
110}
111
ecda0723
SV
112#
113# Add a new submodule to the working tree, .gitmodules and the index
114#
ec05df35 115# $@ = repo path
ecda0723
SV
116#
117# optional branch is stored in global branch variable
118#
23a485e3 119cmd_add()
ecda0723 120{
5c08dbbd
JH
121 # parse $args after "submodule ... add".
122 while test $# -ne 0
123 do
124 case "$1" in
125 -b | --branch)
126 case "$2" in '') usage ;; esac
127 branch=$2
128 shift
129 ;;
130 -q|--quiet)
131 quiet=1
132 ;;
133 --)
134 shift
135 break
136 ;;
137 -*)
138 usage
139 ;;
140 *)
141 break
142 ;;
143 esac
144 shift
145 done
146
ecda0723
SV
147 repo=$1
148 path=$2
149
ec05df35 150 if test -z "$repo" -o -z "$path"; then
ecda0723
SV
151 usage
152 fi
153
ec05df35
ML
154 # assure repo is absolute or relative to parent
155 case "$repo" in
156 ./*|../*)
157 # dereference source url relative to parent's url
158 realrepo=$(resolve_relative_url "$repo") || exit
159 ;;
160 *:*|/*)
161 # absolute url
162 realrepo=$repo
163 ;;
164 *)
165 die "repo URL: '$repo' must be absolute or begin with ./|../"
166 ;;
167 esac
168
169 # strip trailing slashes from path
170 path=$(echo "$path" | sed -e 's|/*$||')
ecda0723 171
5be60078 172 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
ecda0723
SV
173 die "'$path' already exists in the index"
174
d4264ca3
ML
175 # perhaps the path exists and is already a git repo, else clone it
176 if test -e "$path"
177 then
e9656473 178 if test -d "$path"/.git -o -f "$path"/.git
d4264ca3
ML
179 then
180 echo "Adding existing repo at '$path' to the index"
181 else
182 die "'$path' already exists and is not a valid git repo"
183 fi
c2f93917
ML
184
185 case "$repo" in
186 ./*|../*)
187 url=$(resolve_relative_url "$repo") || exit
188 ;;
189 *)
190 url="$repo"
191 ;;
192 esac
193 git config submodule."$path".url "$url"
d4264ca3 194 else
d4264ca3
ML
195
196 module_clone "$path" "$realrepo" || exit
b9b378a0 197 (unset GIT_DIR; cd "$path" && git checkout -f -q ${branch:+-b "$branch" "origin/$branch"}) ||
d4264ca3
ML
198 die "Unable to checkout submodule '$path'"
199 fi
200
ecda0723
SV
201 git add "$path" ||
202 die "Failed to add submodule '$path'"
203
a5099bb4
IY
204 git config -f .gitmodules submodule."$path".path "$path" &&
205 git config -f .gitmodules submodule."$path".url "$repo" &&
ecda0723
SV
206 git add .gitmodules ||
207 die "Failed to register submodule '$path'"
208}
209
19a31f9c
ML
210#
211# Execute an arbitrary command sequence in each checked out
212# submodule
213#
214# $@ = command to execute
215#
216cmd_foreach()
217{
a7b3269c 218 module_list |
19a31f9c
ML
219 while read mode sha1 stage path
220 do
221 if test -e "$path"/.git
222 then
223 say "Entering '$path'"
224 (cd "$path" && eval "$@") ||
225 die "Stopping at '$path'; script returned non-zero status."
226 fi
227 done
228}
229
70c7ac22 230#
211b7f19 231# Register submodules in .git/config
70c7ac22
LH
232#
233# $@ = requested paths (default to all)
234#
23a485e3 235cmd_init()
70c7ac22 236{
5c08dbbd
JH
237 # parse $args after "submodule ... init".
238 while test $# -ne 0
239 do
240 case "$1" in
241 -q|--quiet)
242 quiet=1
243 ;;
244 --)
245 shift
246 break
247 ;;
248 -*)
249 usage
250 ;;
251 *)
252 break
253 ;;
254 esac
255 shift
256 done
257
a7b3269c 258 module_list "$@" |
70c7ac22
LH
259 while read mode sha1 stage path
260 do
211b7f19 261 # Skip already registered paths
941987a5 262 name=$(module_name "$path") || exit
5be60078 263 url=$(git config submodule."$name".url)
211b7f19 264 test -z "$url" || continue
70c7ac22 265
a5099bb4 266 url=$(git config -f .gitmodules submodule."$name".url)
70c7ac22 267 test -z "$url" &&
941987a5 268 die "No url found for submodule path '$path' in .gitmodules"
70c7ac22 269
f31a522a
ML
270 # Possibly a url relative to parent
271 case "$url" in
272 ./*|../*)
8e7e6f39 273 url=$(resolve_relative_url "$url") || exit
f31a522a
ML
274 ;;
275 esac
276
5be60078 277 git config submodule."$name".url "$url" ||
941987a5 278 die "Failed to register url for submodule path '$path'"
70c7ac22 279
941987a5 280 say "Submodule '$name' ($url) registered for path '$path'"
70c7ac22
LH
281 done
282}
283
284#
211b7f19 285# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
286#
287# $@ = requested paths (default to all)
288#
23a485e3 289cmd_update()
70c7ac22 290{
5c08dbbd
JH
291 # parse $args after "submodule ... update".
292 while test $# -ne 0
293 do
294 case "$1" in
295 -q|--quiet)
d1f63a37 296 shift
5c08dbbd
JH
297 quiet=1
298 ;;
be4d2c83
JS
299 -i|--init)
300 shift
301 cmd_init "$@" || return
302 ;;
5c08dbbd
JH
303 --)
304 shift
305 break
306 ;;
307 -*)
308 usage
309 ;;
310 *)
311 break
312 ;;
313 esac
5c08dbbd
JH
314 done
315
a7b3269c 316 module_list "$@" |
70c7ac22
LH
317 while read mode sha1 stage path
318 do
941987a5 319 name=$(module_name "$path") || exit
5be60078 320 url=$(git config submodule."$name".url)
211b7f19 321 if test -z "$url"
70c7ac22
LH
322 then
323 # Only mention uninitialized submodules when its
324 # path have been specified
325 test "$#" != "0" &&
989206f5 326 say "Submodule path '$path' not initialized" &&
be4d2c83 327 say "Maybe you want to use 'update --init'?"
211b7f19
LH
328 continue
329 fi
330
ba88a1fe 331 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19
LH
332 then
333 module_clone "$path" "$url" || exit
bf2d8246
LH
334 subsha1=
335 else
51884080 336 subsha1=$(unset GIT_DIR; cd "$path" &&
5be60078 337 git rev-parse --verify HEAD) ||
941987a5 338 die "Unable to find current revision in submodule path '$path'"
70c7ac22 339 fi
211b7f19 340
70c7ac22
LH
341 if test "$subsha1" != "$sha1"
342 then
b9b378a0
PY
343 force=
344 if test -z "$subsha1"
345 then
346 force="-f"
347 fi
51884080 348 (unset GIT_DIR; cd "$path" && git-fetch &&
b9b378a0 349 git-checkout $force -q "$sha1") ||
941987a5 350 die "Unable to checkout '$sha1' in submodule path '$path'"
70c7ac22 351
941987a5 352 say "Submodule path '$path': checked out '$sha1'"
70c7ac22
LH
353 fi
354 done
355}
356
bffe71f4
EM
357set_name_rev () {
358 revname=$( (
51884080 359 unset GIT_DIR
bffe71f4 360 cd "$1" && {
5be60078
JH
361 git describe "$2" 2>/dev/null ||
362 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
363 git describe --contains "$2" 2>/dev/null ||
364 git describe --all --always "$2"
bffe71f4
EM
365 }
366 ) )
367 test -z "$revname" || revname=" ($revname)"
368}
28f9af5d
PY
369#
370# Show commit summary for submodules in index or working tree
371#
372# If '--cached' is given, show summary between index and given commit,
373# or between working tree and given commit
374#
375# $@ = [commit (default 'HEAD'),] requested paths (default all)
376#
377cmd_summary() {
f2dc06a3 378 summary_limit=-1
d0f64dd4 379 for_status=
f2dc06a3 380
28f9af5d
PY
381 # parse $args after "submodule ... summary".
382 while test $# -ne 0
383 do
384 case "$1" in
385 --cached)
386 cached="$1"
387 ;;
d0f64dd4
PY
388 --for-status)
389 for_status="$1"
390 ;;
f2dc06a3
PY
391 -n|--summary-limit)
392 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
393 then
394 :
395 else
396 usage
397 fi
398 shift
399 ;;
28f9af5d
PY
400 --)
401 shift
402 break
403 ;;
404 -*)
405 usage
406 ;;
407 *)
408 break
409 ;;
410 esac
411 shift
412 done
bffe71f4 413
f2dc06a3
PY
414 test $summary_limit = 0 && return
415
30353a40 416 if rev=$(git rev-parse -q --verify "$1^0")
28f9af5d
PY
417 then
418 head=$rev
419 shift
420 else
421 head=HEAD
422 fi
423
424 cd_to_toplevel
425 # Get modified modules cared by user
426 modules=$(git diff-index $cached --raw $head -- "$@" |
759ad19e 427 egrep '^:([0-7]* )?160000' |
28f9af5d
PY
428 while read mod_src mod_dst sha1_src sha1_dst status name
429 do
430 # Always show modules deleted or type-changed (blob<->module)
431 test $status = D -o $status = T && echo "$name" && continue
432 # Also show added or modified modules which are checked out
433 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
434 echo "$name"
435 done
436 )
1cb639e6 437
d0f64dd4
PY
438 test -z "$modules" && return
439
1cb639e6 440 git diff-index $cached --raw $head -- $modules |
759ad19e 441 egrep '^:([0-7]* )?160000' |
1cb639e6
PY
442 cut -c2- |
443 while read mod_src mod_dst sha1_src sha1_dst status name
444 do
445 if test -z "$cached" &&
446 test $sha1_dst = 0000000000000000000000000000000000000000
447 then
448 case "$mod_dst" in
449 160000)
450 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
451 ;;
452 100644 | 100755 | 120000)
453 sha1_dst=$(git hash-object $name)
454 ;;
455 000000)
456 ;; # removed
457 *)
458 # unexpected type
459 echo >&2 "unexpected mode $mod_dst"
460 continue ;;
461 esac
462 fi
463 missing_src=
464 missing_dst=
465
466 test $mod_src = 160000 &&
30353a40 467 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
468 missing_src=t
469
470 test $mod_dst = 160000 &&
30353a40 471 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 472 missing_dst=t
bffe71f4 473
1cb639e6
PY
474 total_commits=
475 case "$missing_src,$missing_dst" in
476 t,)
477 errmsg=" Warn: $name doesn't contain commit $sha1_src"
478 ;;
479 ,t)
480 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
481 ;;
482 t,t)
483 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
484 ;;
485 *)
486 errmsg=
487 total_commits=$(
488 if test $mod_src = 160000 -a $mod_dst = 160000
489 then
490 range="$sha1_src...$sha1_dst"
491 elif test $mod_src = 160000
492 then
493 range=$sha1_src
494 else
495 range=$sha1_dst
496 fi
497 GIT_DIR="$name/.git" \
498 git log --pretty=oneline --first-parent $range | wc -l
499 )
eed35595 500 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
501 ;;
502 esac
503
504 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
505 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
506 if test $status = T
507 then
508 if test $mod_dst = 160000
509 then
510 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
511 else
512 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
513 fi
514 else
515 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
516 fi
517 if test -n "$errmsg"
518 then
519 # Don't give error msg for modification whose dst is not submodule
520 # i.e. deleted or changed to blob
521 test $mod_dst = 160000 && echo "$errmsg"
522 else
523 if test $mod_src = 160000 -a $mod_dst = 160000
524 then
f2dc06a3
PY
525 limit=
526 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 527 GIT_DIR="$name/.git" \
f2dc06a3 528 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
529 --first-parent $sha1_src...$sha1_dst
530 elif test $mod_dst = 160000
531 then
532 GIT_DIR="$name/.git" \
533 git log --pretty='format: > %s' -1 $sha1_dst
534 else
535 GIT_DIR="$name/.git" \
536 git log --pretty='format: < %s' -1 $sha1_src
537 fi
538 echo
539 fi
540 echo
d0f64dd4
PY
541 done |
542 if test -n "$for_status"; then
543 echo "# Modified submodules:"
544 echo "#"
545 sed -e 's|^|# |' -e 's|^# $|#|'
546 else
547 cat
548 fi
28f9af5d 549}
70c7ac22 550#
941987a5 551# List all submodules, prefixed with:
70c7ac22
LH
552# - submodule not initialized
553# + different revision checked out
554#
555# If --cached was specified the revision in the index will be printed
556# instead of the currently checked out revision.
557#
558# $@ = requested paths (default to all)
559#
23a485e3 560cmd_status()
70c7ac22 561{
5c08dbbd
JH
562 # parse $args after "submodule ... status".
563 while test $# -ne 0
564 do
565 case "$1" in
566 -q|--quiet)
567 quiet=1
568 ;;
569 --cached)
570 cached=1
571 ;;
572 --)
573 shift
574 break
575 ;;
576 -*)
577 usage
578 ;;
579 *)
580 break
581 ;;
582 esac
583 shift
584 done
585
a7b3269c 586 module_list "$@" |
70c7ac22
LH
587 while read mode sha1 stage path
588 do
941987a5 589 name=$(module_name "$path") || exit
5be60078 590 url=$(git config submodule."$name".url)
ba88a1fe 591 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22
LH
592 then
593 say "-$sha1 $path"
594 continue;
595 fi
41c7c1bd 596 set_name_rev "$path" "$sha1"
70c7ac22
LH
597 if git diff-files --quiet -- "$path"
598 then
bffe71f4 599 say " $sha1 $path$revname"
70c7ac22
LH
600 else
601 if test -z "$cached"
602 then
51884080 603 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 604 set_name_rev "$path" "$sha1"
70c7ac22 605 fi
bffe71f4 606 say "+$sha1 $path$revname"
70c7ac22
LH
607 fi
608 done
609}
2327f61e
DA
610#
611# Sync remote urls for submodules
612# This makes the value for remote.$remote.url match the value
613# specified in .gitmodules.
614#
615cmd_sync()
616{
617 while test $# -ne 0
618 do
619 case "$1" in
620 -q|--quiet)
621 quiet=1
622 shift
623 ;;
624 --)
625 shift
626 break
627 ;;
628 -*)
629 usage
630 ;;
631 *)
632 break
633 ;;
634 esac
635 done
636 cd_to_toplevel
637 module_list "$@" |
638 while read mode sha1 stage path
639 do
640 name=$(module_name "$path")
641 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
642
643 # Possibly a url relative to parent
644 case "$url" in
645 ./*|../*)
646 url=$(resolve_relative_url "$url") || exit
647 ;;
648 esac
649
2327f61e
DA
650 if test -e "$path"/.git
651 then
652 (
653 unset GIT_DIR
654 cd "$path"
655 remote=$(get_default_remote)
656 say "Synchronizing submodule url for '$name'"
657 git config remote."$remote".url "$url"
658 )
659 fi
660 done
661}
70c7ac22 662
5c08dbbd
JH
663# This loop parses the command line arguments to find the
664# subcommand name to dispatch. Parsing of the subcommand specific
665# options are primarily done by the subcommand implementations.
666# Subcommand specific options such as --branch and --cached are
667# parsed here as well, for backward compatibility.
668
669while test $# != 0 && test -z "$command"
70c7ac22
LH
670do
671 case "$1" in
2327f61e 672 add | foreach | init | update | status | summary | sync)
5c08dbbd 673 command=$1
70c7ac22
LH
674 ;;
675 -q|--quiet)
676 quiet=1
677 ;;
ecda0723
SV
678 -b|--branch)
679 case "$2" in
680 '')
681 usage
682 ;;
683 esac
684 branch="$2"; shift
685 ;;
70c7ac22 686 --cached)
28f9af5d 687 cached="$1"
70c7ac22
LH
688 ;;
689 --)
690 break
691 ;;
692 -*)
693 usage
694 ;;
695 *)
696 break
697 ;;
698 esac
699 shift
700done
701
5c08dbbd
JH
702# No command word defaults to "status"
703test -n "$command" || command=status
704
705# "-b branch" is accepted only by "add"
706if test -n "$branch" && test "$command" != add
707then
ecda0723 708 usage
5c08dbbd
JH
709fi
710
28f9af5d
PY
711# "--cached" is accepted only by "status" and "summary"
712if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 713then
70c7ac22 714 usage
5c08dbbd
JH
715fi
716
717"cmd_$command" "$@"